/*____________________________________________________________________________

	Class XGIFPicture
____________________________________________________________________________*/

#ifndef __GIFPICT_HPP
#define __GIFPICT_HPP

#ifndef __PICTURE_HPP
	#include "picture.hpp"
#endif


#define OUT_OF_MEMORY 	-10
#define BAD_CODE_SIZE 	-20
#define READ_ERROR 		-1
#define WRITE_ERROR 	-2
#define OPEN_ERROR 		-3
#define CREATE_ERROR 	-4
#define MAX_CODES   	4095


#if 0
#include <palettes.h>

	typedef PaletteHandle XtPalettePointer;
	
	typedef Ptr XtPicturePointer;
	
extern short ParseGIFHeader(
		Ptr *ppGIF,
		unsigned short *pusBitsPerPixel,
		unsigned short *pusCTableSize,
		PaletteHandle *phPalette,
		unsigned short *pusGIFHeight,
		unsigned short *pusGIFWidth
		);

extern OSErr DrawGIF(
		short sWidth,
		short sHeight,
		Ptr pGIF,
		Ptr pBaseAddr,
		short sRowBytes,
		short sPixelSize,
		long lDataSize
		);

#endif


//____________________________________________________________________________
//____________________________________________________________________________
class XGIFPicture : public XPictureBase
{
  public:
	XGIFPicture(CFile & file);
	virtual ~XGIFPicture();

	// Inherited pure virtuals implemented in this class
	virtual short 		height() const;
	virtual short 		width() const;
	virtual XeStatus	draw(	CDC & destDC, 
								const RECT &destRect);
  private:
	long 				mlImageSize;	// size of the image in bytes
	unsigned short		munBitsPerPixel;
	unsigned short		munHeight;
	unsigned short		munWidth;
////	unsigned short 		munCTableSize;	// size of the CTable
	BITMAPINFO *	 	mpsDibHeader;	// Header and palette
	unsigned char * 	mpPictureData;	// pointer to the DIB pixel data

	XeStatus 			ParseGIFHeader(unsigned char * pGIF, unsigned char * & newPtr);
	XeStatus			loadImage(unsigned char * rawImage);
};


#endif  //__GIFPICT_HPP
